


 '-------------------------------------------------------------
 '----------------- QFILELISTBOX files popupmenu---------------
 '-------------------------------------------------------------

CREATE ProjFileList_PopupMenu AS QPopupMenu
    Alignment = 1
    CREATE ProjFileList_Menu1 AS QMenuItem
        Caption = "Open"
        OnClick = DirListFileSelect
    END CREATE
    CREATE ProjFileList_Menu2 AS QMenuItem
        Caption = "-"
        Enabled = False
    END CREATE
    CREATE ProjFileList_Menu3 AS QMenuItem
        Caption = "Explore Folder"
        OnClick = ProjFileList_Explore
    END CREATE
    CREATE ProjFileList_Menu4 AS QMenuItem
        Caption = "Delete"
        OnClick = ProjFileList_Delete
    END CREATE
END CREATE

 '-------------------------------------------------------------
 '----------------- End QFILELISTBOX files popupmenu ----------
 '-------------------------------------------------------------





CREATE TabControl3 AS QTABCONTROL
    Parent = RightPanel
    MultiLine = True
    TabHeight = 21
    Top = 22
    Left = 1
    Width = 183
    Height = 423
    Align = alClient
    AddTabs("Project" , "Includes" , "Find", "Subs")
    ShowHint = 0
    FocusButtons = 0          'FlatButtons=1              'ButtonStyle = 1
    FlatSeperators = True
    TabInactiveColor = clBtnFace
    OnChange = RightTabChange

    '------------------  Panel for Project  ------------------
    CREATE ProjPanel AS QPANEL
        Align = alClient
        Width = 800
        Visible = True


        CREATE ProjFileList AS QFILELISTBOX
            'Directory = Application.Path       'not working??
            Align = alBottom
            Left = 1
            Width = ProjPanel.Width
            Height = MainForm.ClientHeight / 4
            Top = 24
            ShowIcons = True
            Mask = "*.bas;*.txt;*.inc;*.rq;*.rqb;*.rqw"
            Hint = "Double click to open"
            ShowHint = True
            PopupMenu = ProjFileList_PopupMenu
            OnDblClick = DirListFileSelect
            OnClick = DirListFileSelect 'ProjFileList_Click
        END CREATE

        CREATE Splitter22 AS QSPLITTER
            Align = alBottom
            Width  = ProjPanel.Width
            Height = 6
            Beveled = 1
            Cursor = crVSplit
        END CREATE

        CREATE ProjFileListMaskEdit AS QCOMBOBOX
            Align = alTop
            Top = 0
            Left = 1
            Width = ProjPanel.Width
            AddItems ("*.bas;*.inc;*.rq;*.rqb;*.rqw;*.bi;*.txt")
            AddItems ("*.bas;*.rqb;*.inc")
            AddItems ("*.bas")
            AddItems ("*.inc")
            AddItems ("*.txt")
            AddItems ("*.*")
            Text = "*.bas;*.inc;*.rq;*.rqb;*.rqw;*.bi;*.txt"
            OnChange = ProjFileList_Update
        END CREATE

        CREATE DirTree AS QDIRTREE          'only one of these per app!!
            OnChange = ChangeDirectories
            InitialDir = Application.Path
            Height = MainForm.ClientHeight / 4
            Width  = ProjPanel.Width
            Align = alClient
            Top = 2         'ProjFileListMaskEdit.Top + ProjFileListMaskEdit.Height + 1
            Left = 1
        END CREATE

    END CREATE


    '------------------  Panel for Include and Resource files  ------------------
    CREATE IncResPanel AS QPANEL
        Align = 5
        Width = 800
        BevelInner = bvLowered
        Visible = False

        CREATE MainListBoxResources AS QLISTBOX        'resources
            Align = alBottom
            Top = 2
            Left = 2
            Height = MainForm.ClientHeight / 4
            OnClick = ResourceListFileSelect
            OnDblClick = ResourceListFileEdit
        END CREATE

        CREATE Splitter22b AS QSPLITTER
            Align = alBottom
            Width  = 10
            Beveled = 1
            Cursor = crVSplit
        END CREATE

        CREATE labelincludes AS QLABEL
            Caption = "Include and Resource files"
            Left = 0
            Top = 0
            Width = 312
            Height = 22
            Align = alTop
            Color = clWhite
        END CREATE

        CREATE MainListBoxIncludes AS QLISTBOX        'file di inclusione
            Parent = IncResPanel
            Align = alClient
            Top = 2
            Left = 2
            Height = MainForm.ClientHeight / 4
            OnClick = IncludeListFileSelect
        END CREATE
    END CREATE


    '------------------  Panel for Search results  ------------------
    CREATE FindAllPanel AS QPANEL
        Align = alClient
        Width = 800
        BevelInner = bvLowered
        Visible = False

'        CREATE ConvertFindToBookMarks AS QLABEL
'            Caption = "Bookmark all"
'            Left = 0
'            Top = 0
'            Width = 312
'            Height = 18
'            Align = alTop
'            Color = clWhite
'            OnClick = ConvertFindToBookMarks_Click
'        END CREATE

    END CREATE


    '------------------  Panel for Subs/Functions  ------------------
    CREATE SubFuncsPanel AS QPANEL
        Align = alClient
        Width = TabControl3.ClientWidth  ' 800
        Height = TabControl3.ClientHeight
        BevelInner = bvLowered
        Visible = False
    END CREATE

END CREATE          'tab Control


SUB ListViewColumn_Click(Column as integer, Sender AS QListView)
    RightPanelRefresh
    Sender.SortType = stText
    Sender.SortType = stNone
'    IF Sender.SortType = stNone THEN Sender.SortType = stText ELSE Sender.SortType = stNone
END SUB



DIM SubFuncListView(IDE_MAX_FILES) AS QLISTVIEW
FOR zzz = 0 TO IDE_MAX_FILES
	SubFuncListView(zzz).Parent = SubFuncsPanel
	SubFuncListView(zzz).Visible = False
	SubFuncListView(zzz).Tag = zzz
	SubFuncListView(zzz).ReadOnly = True
	SubFuncListView(zzz).OnColumnClick = ListViewColumn_Click
	SubFuncListView(zzz).Width = SubFuncsPanel.Width 
	SubFuncListView(zzz).Height = SubFuncsPanel.Height
	SubFuncListView(zzz).SmallImages = SubFuncImageList
	SubFuncListView(zzz).ViewStyle = vsReport
	SubFuncListView(zzz).AddColumns "Sub/Func Refresh"
'    SubFuncListView(zzz).ShowColumnHeaders = False         'crash-ola
	SubFuncListView(zzz).Column(0).Width = SubFuncsPanel.Width
	SubFuncListView(zzz).OnDblClick = SubFuncListView_Click
	SubFuncListView(zzz).OnClick = SubFuncListView_Click
NEXT zzz



 
  