
'=========================================================================
' PAINT Version 1.1 6/9/2010
' Auteur:D.Glodt, modified by JohnK
'=========================================================================
$typecheck on
$OPTION ICON "palet.ico"
$include <rapidq2.inc>
$include <QFuncLib.inc>
$INCLUDE <QDrawFocus.INC>

'==========================================================================
' ressources bitmap
'==========================================================================
$resource ico as "palet.ico" 
$resource Btview2_bmp as "Btview2.bmp"
$resource Btfocus_bmp as "Btfocus.bmp"
$resource Btpipe_bmp as "Btpipe.bmp"
$resource Btfill_bmp as "Btfill.bmp"
$resource Bttext_bmp as "Bttext.bmp"
$resource BtPen_bmp as "BtPen.bmp"
$resource Btpaint_bmp as "Btpaint.bmp"
$resource Btline_bmp as "Btline.bmp"
$resource Btsquare_bmp as "Btsquare.bmp"
$resource BtsquareFilled_bmp as "BtsquareFilled.bmp"
$resource Btcircle_bmp as "Btcircle.bmp"
$resource BtcircleFilled_bmp as "BtcircleFilled.bmp"
'==========================================================================
' declarations routines
'==========================================================================
declare function LoadCursorFromFile LIB "USER32" ALIAS "LoadCursorFromFileA" (CursorFileName AS STRING) AS LONG

Screen.Cursors(1)= LoadCursorFromFile("PEN.CUR")
Screen.Cursors(2)= LoadCursorFromFile("FILL.CUR")
Screen.Cursors(3)= LoadCursorFromFile("PICK.CUR")
Screen.Cursors(4)= LoadCursorFromFile("SPRAY.CUR")
Screen.Cursors(5)= LoadCursorFromFile("BRUSH.CUR")

declare function ExtractFileName(FileName as string) as string
declare sub Paint
declare sub SelectMenuExit
declare sub SelectMenuNew
declare sub SelectMenuOpen
declare sub SelectMenuClose
declare sub SelectPenColor
declare sub SelectBackcolor
declare sub move(x as integer,y as integer)
declare sub start(bt as integer,x as integer,y as integer)
declare sub stop 
declare sub SelectPipe 
declare sub SelectZoom
declare sub SelectPen
declare sub SelectPaint
declare sub SelectLine
declare sub SelectRect
declare sub SelectRectFilled
declare sub SelectCircle
declare sub SelectCircleFilled
declare sub SelectFill
declare sub SelectText
declare sub SelectTextFont
declare sub SelectMenuMirrorX
declare sub SelectMenuMirrorY
declare sub SelectMenuInvert
declare sub SelectMenuInvertColor
declare sub SelectMenuColoring
declare sub SelectMenuTransparentImage
declare sub SelectMenuRemoveColor
declare sub SelectMenuRotation
declare sub SelectFocus
declare sub SelectMenuEdit
declare sub SelectMenuCopy
declare sub SelectMenuPaste
declare sub SelectMenuPasteFrom
declare sub SelectMenuCut
declare sub SelectMenuTransparent
declare sub SelectMenuUndo
declare sub SelectMenuSaveAs
declare sub SelectMenuSave
declare sub SelectMenuDimensions
declare sub SelectMenuFormat16
declare sub SelectMenuFormat256
declare sub SelectMenuFormat24
declare sub OkDimensions
declare sub OkText
declare sub AnnulerText
declare sub AnnulerDimensions
declare sub OkZoom
declare sub AnnulerZoom
declare sub SelectPenSize
declare sub Grille
declare sub Zoom
declare sub ResizePaint
declare sub ResetPaste
declare sub TransfertImgUndo
Declare Sub FermerEcran(Key as word)
Declare Sub SelectMenuImageShow
Declare Sub SelectMenuAbout
Declare Sub ResetButton
Declare Sub ShowFormat
Declare Sub OpenCL
Declare Sub CreateColorGrid
Declare Sub PickColors(Button%, X%, Y%, Shift%,Sender as QPanel)
'==========================================================================
' declarations donnes
'==========================================================================
const VK_ESCAPE=27
dim imgWidth as integer
dim imgHeight as integer
    imgWidth=200
    imgHeight=200
dim TypeDraw as integer
      TypeDraw=0
dim MemoTypeDraw as integer
      MemoTypeDraw=0
dim FlagDraw as integer
dim pencolor as long
       pencolor=&h0
dim backcolor as long        
      backcolor=&hffffff        
dim imgMemory as QBitmapEx
    imgMemory.width=imgWidth
    imgMemory.height=imgHeight
    imgMemory.pixelformat=pf24bit
    imgMemory.FillRect(0,0,imgWidth,imgHeight,&hffffff)
dim ImgTmp as QBitmap
dim ImgZoom as QBitmap
dim ImgEffect as QBitmapEx
dim ImgUndo as QBitmap
dim Open as QOpendialog
      Open.caption="Open image"
      Open.Filter="Files bitmap(*.bmp)|*.bmp"
dim SaveDialog as QSaveDialog
    SaveDialog.Filter="Files bitmap(*.bmp)|*.bmp"
    SaveDialog.Caption= "Save image"
dim ColorDial as QColorDialog
dim orx as integer
dim ory as integer
dim ox as integer
dim oy as integer
dim source as QRect 
dim dest as QRect 
const ValZoom=800
dim flagZoom as integer 
dim flagPaste as integer 
dim flagUndo as integer 
dim flagModif as integer 
const ZoomWidth=100 
const ZoomHeight=100 
dim flagText as integer
dim leftText as integer
dim topText as integer 
dim focus as QDrawFocus
dim fontdialog as QFontDialog
dim font as QFont
dim FileName as string
    FileName="Noname"
dim about as QAbout
dim p(15) as QPanel
dim offset as integer

'==========================================================================
' interface application
'==========================================================================
CREATE Form1 AS QFORMEX
  IcoHandle = ico
  Caption=Application.title+" - "+FileName
  Width=600
  Height=400
  Center
  CREATE Panel1 AS QPANEL
    Left=0
    Top=0
    Width=62
    Height=400
    BevelOuter=0
    Align=3
    CREATE BtZoom AS QCOOLBTN
      BmpHandle=Btview2_bmp
      Left=5
      Top=0
      Width=24
      Height=24
      ShowHint=true
      Hint="Zoom"
      GroupIndex=2
      AllowAllUp=true
      OnClick=SelectZoom
    END CREATE
    CREATE BtFocus AS QCOOLBTN
      BMPHandle=Btfocus_bmp
      Left=29
      Top=0
      Width=24
      Height=24
      ShowHint=1
      Hint="Focus"
      GroupIndex=1
      AllowAllUp=true
      OnClick=SelectFocus
    END CREATE
    CREATE BtPipe AS QCOOLBTN
      BMPHandle=Btpipe_bmp
      Left=5
      Top=24
      Width=24
      Height=24
      ShowHint=1
      Hint="Pick Color"
      GroupIndex=1
      OnClick=SelectPipe
      AllowAllUp=true
    END CREATE
    CREATE BtFill AS QCOOLBTN
      BMPHandle=Btfill_bmp
      Left=29
      Top=24
      Width=24
      Height=24
      ShowHint=1
      Hint="Fill"
      GroupIndex=1
      AllowAllUp=true
      OnClick=SelectFill
    END CREATE
    CREATE BtText AS QCOOLBTN
      BMPHandle=Bttext_bmp
      Left=5
      Top=48
      Width=24
      Height=24
      ShowHint=1
      Hint="Text"
      GroupIndex=1
      AllowAllUp=true
      OnClick=SelectText
    END CREATE
    CREATE BtBrush AS QCOOLBTN
      BMPHandle=BtPaint_bmp
      Left=29
      Top=48
      Width=24
      Height=24
      ShowHint=1
      Hint="Brush"
      GroupIndex=1
      AllowAllUp=true
      OnClick=SelectPaint
    END CREATE
    CREATE BtPen AS QCOOLBTN
      BMPHandle=BtPen_bmp
      Left=5
      Top=72
      Width=24
      Height=24
      ShowHint=1
      Hint="Pen"
      GroupIndex=1
      AllowAllUp=true
      OnClick=SelectPen
    END CREATE
    CREATE BtLine AS QCOOLBTN
      BMPHandle=Btline_bmp
      Left=29
      Top=72
      Width=24
      Height=24
      ShowHint=1
      Hint="Line"
      GroupIndex=1
      AllowAllUp=true
      OnClick=SelectLine
    END CREATE
    CREATE BtSquare AS QCOOLBTN
      BMPHandle=Btsquare_bmp
      Left=5
      Top=96
      Width=24
      Height=24
      ShowHint=1
      Hint="Rectangle"
      GroupIndex=1
      AllowAllUp=true
      OnClick=SelectRect
    END CREATE
    CREATE BtSquareFilled AS QCOOLBTN
      BMPHandle=BtsquareFilled_bmp
      Left=29
      Top=96
      Width=24
      Height=24
      ShowHint=1
      Hint="Filled Rectangle"
      GroupIndex=1
      AllowAllUp=true
      OnClick=SelectRectFilled
    END CREATE
    CREATE BtCircle AS QCOOLBTN
      BMPHandle=Btcircle_bmp
      Left=5
      Top=120
      Width=24
      Height=24
      ShowHint=1
      Hint="Ellipse"
      GroupIndex=1
      AllowAllUp=true
      OnClick=SelectCircle
    END CREATE
    CREATE BtCircleFilled AS QCOOLBTN
      BMPHandle=BtcircleFilled_bmp
      Left=29
      Top=120
      Width=24
      Height=24
      ShowHint=1
      Hint="Filled Ellipse"
      GroupIndex=1
      AllowAllUp=true
      OnClick=SelectCircleFilled
    END CREATE
    CREATE Pn AS QPANEL
      Top =  154
      Left = 5
      Width = 50
      Height = 50
      BevelInner = bvLowered
      BevelOuter = bvNone
    CREATE Panel3 AS QPANEL
      Left=5
      Top=10
      Width=22
      Height=22
      BevelInner= bvNone
      BevelOuter= bvNone
      ShowHint=1
      Hint= "Background Color"
      Color=&h0
      OnClick=SelectBackcolor
    END CREATE
    CREATE Panel2 AS QPANEL
      Left=22
      Top= 20
      Width=22
      Height=22
      BevelInner= bvNone
      BevelOuter= bvNone
      ShowHint=1
      Hint="Pen Color"
      Color=&hffffff
      OnClick=SelectPenColor
    END CREATE
    END CREATE
    CREATE PenSize AS QCOMBOBOX
      style=2
      AddItems "1","2","3","4","5","6","7","8","9","10"
      Left=5
      Top=214
      Width=49
      ShowHint=1
      Hint="Pen Size"
      ItemIndex=0
      OnChange=SelectPenSize
    END CREATE
  END CREATE
  CREATE ScrollBox1 AS QSCROLLBOX
    AutoScroll=true
    Align=5
    HorzTracking=true
    VertTracking=true
    color=&H808080
    CREATE Image AS QCANVASEX
      left=0
      top=0
      width=imgWidth
      height=imgHeight
      color=&hffffff
      OnPaint=Paint
      OnMouseMove=move
      OnMouseDown=start
      OnMouseUp=stop 
    END CREATE
    OnResize=ResizePaint
  END CREATE
  CREATE StatusBar AS QSTATUSBAR
    Align = alBottom
    AddPanels "0","1","2"
    Panel(0).Caption = ""
    Panel(0).Width = 100
    Panel(0).Alignment = taCenter
    Panel(1).Caption = ""
    Panel(1).Width = 120
    Panel(1).Alignment = taCenter
    Panel(2).Caption = ""
    Panel(2).Alignment = taCenter
  END CREATE
  CREATE cgPanel AS QPANEL
    Height = 34
    Align = alBottom
    BevelInner = bvNone
    BevelOuter = bvNone
  END CREATE
  OnClose=SelectMenuExit
  OnResize=ResizePaint
  OnPaint = CreateColorGrid
END CREATE

'==========================================================================
' menu application
'==========================================================================
CREATE MainMenu AS QMAINMENU
  parent=Form1
  CREATE FileMenu AS QMENUITEM
    Caption="File"
    CREATE ItemNew AS QMENUITEM
      Caption="New"
      OnClick=SelectMenuNew
    END CREATE
    CREATE ItemOpen AS QMENUITEM
      Caption="Open"
      OnClick=SelectMenuOpen
    END CREATE
    CREATE ItemClose AS QMENUITEM
      Caption="Close"
      OnClick=SelectMenuClose
    END CREATE
    CREATE ItemSave AS QMENUITEM
      Caption="Save"
      OnClick=SelectMenuSave
    END CREATE
    CREATE ItemSaveAs AS QMENUITEM
      Caption="Save As..."
      OnClick=SelectMenuSaveAs
    END CREATE
    CREATE ItemSeparator1 AS QMENUITEM
      Caption="-"
    END CREATE
    CREATE ItemQuit AS QMENUITEM
      Caption="Exit"
      OnClick=SelectMenuExit
    END CREATE
  END CREATE
  CREATE EditMenu AS QMENUITEM
    Caption="Edit"
    OnClick=SelectMenuEdit
    CREATE ItemUndo AS QMENUITEM
      Caption="Undo"
      Enabled=false
      OnClick=SelectMenuUndo
    END CREATE
    CREATE ItemSeparator2 AS QMENUITEM
      Caption="-"
    END CREATE
    CREATE ItemCut AS QMENUITEM
      Caption="Cut"
      Enabled=false
      OnClick=SelectMenuCut
    END CREATE
    CREATE ItemCopy AS QMENUITEM
      Caption="Copy"
      Enabled=false
      OnClick=SelectMenuCopy
    END CREATE
    CREATE ItemPaste AS QMENUITEM
      Caption="Paste"
      Enabled=false
      OnClick=SelectMenuPaste
    END CREATE
    CREATE ItemPasteFrom AS QMENUITEM
      Caption="Paste From..."
      OnClick=SelectMenuPasteFrom
    END CREATE
    CREATE ItemTransparent AS QMENUITEM
      Caption="Transparent"
      OnClick=SelectMenuTransparent
    END CREATE
  END CREATE
  CREATE ShowMenu AS QMENUITEM
    Caption="Show"
    CREATE ItemImageShow AS QMENUITEM
      Caption="Image Show"
      OnClick=SelectMenuImageShow
    END CREATE
  END CREATE
  CREATE ImageMenu AS QMENUITEM
    Caption="Image"
    CREATE ItemDimensions AS QMENUITEM
      Caption="Dimensions..."
      OnClick=SelectMenuDimensions
    END CREATE
    CREATE ItemSeparator3 AS QMENUITEM
      Caption="-"
    END CREATE
    CREATE ItemMirrorX AS QMENUITEM
      Caption="Mirror X"
      OnClick=SelectMenuMirrorX
    END CREATE
    CREATE ItemMirrorY AS QMENUITEM
      Caption="Mirror Y"
      OnClick=SelectMenuMirrorY
    END CREATE
    CREATE ItemTurn90 AS QMENUITEM
      Caption="Turn 90"
      OnClick=SelectMenuRotation
    END CREATE
    CREATE ItemInvertColor AS QMENUITEM
      Caption="Invert colors"
      OnClick=SelectMenuInvert
    END CREATE
    CREATE ItemNegatifColor AS QMENUITEM
      Caption="Negativ color"
      OnClick=SelectMenuInvertColor
    END CREATE
    CREATE ItemColoring AS QMENUITEM
      Caption="Coloring"
      OnClick=SelectMenuColoring
    END CREATE
    CREATE ItemTransparentImage AS QMENUITEM
      Caption="Transparent"
      OnClick=SelectMenuTransparentImage
    END CREATE
    CREATE ItemRemoveColor AS QMENUITEM
      Caption="Remove color"
      OnClick=SelectMenuRemoveColor
    END CREATE
    CREATE ItemConvertFormat AS QMENUITEM
      Caption="&Convert color format"
      CREATE ItemFormat16 AS QMENUITEM
        Caption="Format 16 colors"
        OnClick=SelectMenuFormat16
      END CREATE
      CREATE ItemFormat256 AS QMENUITEM
        Caption="Format 256 colors"
        OnClick=SelectMenuFormat256
      END CREATE
      CREATE ItemFormat24 AS QMENUITEM
        Caption="Format coulors 24 bits"
        OnClick=SelectMenuFormat24
      END CREATE
    END CREATE
  END CREATE
  CREATE HelpMenu AS QMENUITEM
    Caption="?"
    CREATE ItemAbout AS QMENUITEM
      Caption="About..."
      OnClick=SelectMenuAbout
    END CREATE
  END CREATE
END CREATE


'==========================================================================
' boite dialogue dimensions
'==========================================================================
CREATE Form2 AS QFORM
  Caption="Dimensions"
  Width=280
  Height=140
  Center
  BorderStyle=3
  CREATE GROUPBOX AS QGROUPBOX
    Caption = " Bitmap Dimensions "
    Align = alClient
  CREATE Label1 AS QLABEL
    Caption="Width :"
    Left=10
    Top=21
    Width=48
    Height=21
    Transparent=1
  END CREATE
  CREATE Label2 AS QLABEL
    Caption="Height :"
    Left=10
    Top=47
    Width=40
    Transparent=1
  END CREATE
  CREATE WidthEdit AS QEDIT
    Left=55
    Top=20
    Width=60
    TabOrder=1
  END CREATE
  CREATE HeightEdit AS QEDIT
    Left=55
    Top=45
    Width=60
    TabOrder=2
  END CREATE
  CREATE CheckStretch AS QCHECKBOX
    Caption="Stretch"
    Left=135
    Top=20
    Width=137
    TabOrder=3
  END CREATE
  CREATE BtOk AS QBUTTON
    Caption="Ok"
    Left=130
    Top=82
    Width=59
    TabOrder=4
    OnClick=OkDimensions
  END CREATE
  CREATE BtUndo AS QBUTTON
    Caption="Abort"
    Left=200
    Top=82
    Width=59
    TabOrder=5
    OnClick=AnnulerDimensions
  END CREATE
  END CREATE
END CREATE


'==========================================================================
' boite dialogue insertion texte
'==========================================================================
CREATE Form3 AS QFORM
  Caption="Text"
  Width=347
  Height=125
  BorderStyle=3
  Center
  CREATE BtTextFont AS QBUTTON
    Caption="Font"
    Left=266
    Top=3
    Width=67
    OnClick=SelectTextFont
  END CREATE
  CREATE BtTextUndo AS QBUTTON
    Caption="Undo Text"
    Left=266
    Top=34
    Width=67
    OnClick=AnnulerText
  END CREATE
  CREATE BtTextOk AS QBUTTON
    Caption="Ok"
    Left=266
    Top=64
    Width=67
    OnClick=OkText
  END CREATE
  CREATE EdText AS QEDIT
    autosize=false
    Left=5
    Top=3
    Width=249
    Height=89
  END CREATE
END CREATE

'========================================================
' fenetre ecran
'========================================================
CREATE Form4 as QFORM
  BorderStyle=bsNone
  top=0
  left=0
  width=Screen.Width
  height=Screen.Height
  color=&H0
  cursor=crnone
  OnKeyDown=FermerEcran
  CREATE ecran as QIMAGE
    visible=false
    stretch=true
  END CREATE
END CREATE


'-- command line
if CommandCount = 1 then
   FileName = Command$(1)
   OpenCl
end if

Form1.ShowModal

'------------------------------- ExtractFileName -------------------------------------------
Function ExtractFileName(FileName as string) as string
	Dim Length as integer
	Length = RInStr(FileName, "\\") or RInStr(FileName, "/") or RInStr(FileName, "\")
	Result = MID$(FileName, Length+1, LEN(FileName) - Length + 1)
End Function
'------------------------------ PickColors ------------------------------------------------
Sub PickColors(Button%, X%, Y%, Shift%, Sender as QPanel)
if Button% = 0 then  ' add in rapidq.inc ( mbLeft = 0, mbRight = 1, mbMiddle = 2)
   Panel2.Color = Sender.Color
   pencolor = Sender.Color
   end if
if Button% = 1 then
   Panel3.Color = Sender.Color
   backcolor = Sender.Color
   end if
End Sub
'-------------------------------- Create colorGrid ----------------------------------------
Sub CreateColorGrid
dim i as integer

offset = 0
for i = 0 to 15 do
p(i).Parent = cgPanel
p(i).Width = 20
p(i).Height = 20
p(i).Top = 7
p(i).Left = offset + 2
p(i).BevelInner = bvlowered
p(i).BevelOuter = bvNone
p(i).Color = QBcolor(i)
p(i).Hint = " Left Click: PenColor" + _
             chr$(10)+"-----------------------------------------------" + _
             chr$(10)+ " Right Click: BackgroundColor "
p(i).ShowHint = True
p(i).OnMouseDown = PickColors
inc(offset,20)
next i
StatusBar.Panel(0).Caption = Format$(" %d x %d ", Image.Width, Image.Height)
End Sub

'============================
' Evenement affichage image
'============================
Sub Paint
  image.draw(0,0,imgMemory.bmp)
  if BtZoom.down and flagZoom then Grille
  if flagText then
    image.textout(leftText,topText,EdText.text,font.Color,&hffffff)
    imgMemory.textout(leftText,topText,EdText.text,font.Color,&hffffff)
    flagText=false
  end if
  if focus.visible then
    focus.visible=false 
    focus.start(image.handle,focus.left,focus.top) 
    focus.draw(image.handle,focus.left+focus.width,focus.top+focus.height,true) 
  end if
End Sub

'======================================
' Evenement resize fenetre principale
'======================================
Sub ResizePaint
  image.repaint
End Sub

'============================
' Selection menu edition
'============================
Sub SelectMenuEdit
  if btFocus.down and focus.visible and btZoom.down=false then
    ItemCut.enabled=true
    ItemCopy.enabled=true
  end if
  if image.canPaste() then
    ItemPaste.enabled=true
  end if
  if FlagUndo then
    ItemUndo.enabled=true
  else
    ItemUndo.enabled=false
  end if
End Sub

'============================
' Selection menu annuler
'============================
Sub SelectMenuUndo
  if focus.visible then focus.remove(image.handle)
  ImgMemory.width=ImgUndo.width
  ImgMemory.height=ImgUndo.height
  ImgMemory.pixelFormat=ImgUndo.pixelFormat
  ImgMemory.bmp=ImgUndo.bmp
  ImgWidth=ImgUndo.width
  ImgHeight=ImgUndo.height
  Image.width=ImgWidth
  Image.height=ImgHeight
  Image.repaint
  FlagUndo=false
  FlagPaste=false
  ShowFormat
End Sub

'============================
' Selection menu copier
'============================
Sub SelectMenuCopy
  Source.left=focus.left+1
  Source.top=focus.top+1
  Source.right=focus.left+focus.width-1
  Source.bottom=focus.top+focus.height-1
  image.CopyToClipboard(Source)
End Sub

'============================
' Selection menu couper
'============================
Sub SelectMenuCut
  TransfertImgUndo
  Source.left=focus.left+1
  Source.top=focus.top+1
  Source.right=focus.left+focus.width-1
  Source.bottom=focus.top+focus.height-1
  image.CopyToClipboard(Source)
  if focus.visible then focus.remove(image.handle)
  ImgMemory.fillRect(focus.left+1,focus.top+1,focus.left+focus.width-1,focus.top+focus.height-1,&hffffff)
  image.repaint
End Sub

'============================
' Selection menu coller
'============================
Sub SelectMenuPaste
  ResetButton
  if focus.visible then focus.remove(image.handle)
  ImgEffect.width=ImgEffect.GetWidthClipboard()
  ImgEffect.height=ImgEffect.GetHeightClipboard()
  ImgEffect.PasteFromClipboard(0,0)
  if ItemTransparent.checked then
    ImgEffect.transparent=true
    ImgEffect.transparentColor=backcolor
  else
    ImgEffect.transparent=false
  end if
  image.draw(0,0,ImgEffect.bmp)
  focus.noResize=true
  focus.start(image.handle,0,0)
  focus.draw(image.handle,ImgEffect.width,ImgEffect.height,true)
  TypeDraw=10
  FlagPaste=true
End Sub

'=============================================
' Selection menu coller a partir d'un fichier
'=============================================
Sub SelectMenuPasteFrom
  ResetButton
  if focus.visible then focus.remove(image.handle)
  if Open.Execute then
    ImgEffect.Bmp=Open.FileName
    ImgEffect.pixelformat=ImgMemory.pixelformat
    if ItemTransparent.checked then
      ImgEffect.transparent=true
      ImgEffect.transparentColor=backcolor
    else
      ImgEffect.transparent=false
    end if
    image.draw(0,0,ImgEffect.bmp)
    focus.noResize=true
    focus.start(image.handle,0,0)
    focus.draw(image.handle,ImgEffect.width,ImgEffect.height,true)
    TypeDraw=10
    FlagPaste=true
  end if 
End Sub

'==================================================
' Coller image du presse papier si autre selection
'==================================================
Sub ResetPaste
  if FlagPaste then
    focus.remove(image.handle)
    focus.stop(image.handle,false)
    ImgMemory.draw(0,0,ImgEffect.bmp)
    TypeDraw=0
    image.repaint
    FlagPaste=false
    FlagUndo=true
    FlagModif=true
  end if
End Sub

'============================
' Selection menu transparent
'============================
Sub SelectMenuTransparent
  if ItemTransparent.checked then
    ItemTransparent.checked=false
  else
    ItemTransparent.checked=true
  end if
End Sub

'============================
' Selection menu quitter
'============================
Sub SelectMenuExit
  Dim msgButton as integer
  
  if FlagModif then
    msgButton=MessageBox("Save file " + FileName + " ?",application.title,35)
    if msgButton<>mrCancel then
      if msgButton=mrYes then
        SelectMenuSave
      end if
      application.terminate
    else
      form1.modalresult=0
    end if
  else
    application.terminate
  end if
End Sub

'============================
' Selection menu nouveau
'============================
Sub SelectMenuNew
  Dim msgButton as integer
  
  if FlagModif then
    msgButton=MessageBox("Save file "+ ExtractFileName(FileName) + " ?"  ,application.title,35)
    if msgButton<>mrCancel then
      if msgButton=mrYes then
        SelectMenuSave
      end if
      FlagUndo=false
      FlagModif=false
      if focus.visible then focus.remove(image.handle)
      ImgMemory.pixelformat=pf24bit
      ShowFormat
      imgMemory.fillrect(0,0,imgMemory.width,imgMemory.height,&hffffff)
      image.repaint
      filename="Noname"
      form1.caption=application.title + " - " + ExtractFileName(FileName)
    end if
  else
    FlagUndo=false
    FlagModif=false
    if focus.visible then focus.remove(image.handle)
    ImgMemory.pixelformat=pf24bit
    ShowFormat
    imgMemory.fillrect(0,0,imgMemory.width,imgMemory.height,&hffffff)
    image.repaint
    filename="Noname"
    form1.caption=application.title + " - " + ExtractFileName(FileName)
  end if
StatusBar.Panel(0).Caption = Format$(" %d x %d ", imgWidth , imgHeight)
StatusBar.Panel(2).Caption = ""
End Sub

'============================
' Selection menu fermer
'============================
Sub SelectMenuClose
  Dim msgButton as integer
  
  if FlagModif then
    msgButton=MessageBox("Save file " + ExtractFileName(FileName) + " ?",application.title,35)
    if msgButton<>mrCancel then
      if msgButton=mrYes then
        SelectMenuSave
      end if
      FlagUndo=false
      FlagModif=false
      if focus.visible then focus.remove(image.handle)
      ImgMemory.pixelformat=pf24bit
      ShowFormat
      imgMemory.fillrect(0,0,imgMemory.width,imgMemory.height,&hffffff)
      image.repaint
      filename="Noname"
      form1.caption=application.title+" - "+filename
    end if
  else
    FlagUndo=false
    FlagModif=false
    if focus.visible then focus.remove(image.handle)
    ImgMemory.pixelformat=pf24bit
    ShowFormat
    imgMemory.fillrect(0,0,imgMemory.width,imgMemory.height,&hffffff)
    image.repaint
    filename="Noname"
    form1.caption=application.title + " - " + ExtractFileName(FileName)
  end if
End Sub

'----------------------------
' Open by commandline
'----------------------------
Sub OpenCL
if focus.visible then
focus.remove(image.handle)
End if
        imgMemory.Bmp=FileName
        image.width=imgMemory.width
        image.height=imgMemory.height
        imgWidth=imgMemory.width
        imgHeight=imgMemory.height
        Form1.Caption=application.title + " - " + ExtractFileName(FileName)
        ShowFormat
        Image.repaint
End Sub

'============================
' Selection menu ouvrir
'============================
Sub SelectMenuOpen
  Dim msgButton as integer

  if FlagModif then
    msgButton=MessageBox("Save file " + ExtractFileName(FileName) +" ?",application.title,35)
    if msgButton<>mrCancel then
      if msgButton=mrYes then
        SelectMenuSave
      end if
      FlagUndo=false
      FlagModif=false
      Open.InitialDir=CurDir$
      if Open.Execute then
        if focus.visible then focus.remove(image.handle)
        imgMemory.Bmp=Open.FileName
        FileName=Open.FileName
        image.width=imgMemory.width
        image.height=imgMemory.height
        imgWidth=imgMemory.width
        imgHeight=imgMemory.height
        Form1.Caption=application.title + " - " + ExtractFileName(FileName)
        ShowFormat
        Image.repaint
      end if
    end if
  else
    Open.InitialDir=CurDir$
    FlagUndo=false
    FlagModif=false
    if Open.Execute then
      if focus.visible then focus.remove(image.handle)
      imgMemory.Bmp=Open.FileName
      FileName=Open.FileName
      image.width=imgMemory.width
      image.height=imgMemory.height
      imgWidth=imgMemory.width
      imgHeight=imgMemory.height
      Form1.Caption=application.title+" - " + ExtractFileName(FileName)
      ShowFormat
      Image.repaint
    end if
  end if
StatusBar.Panel(0).Caption = Format$(" %d x %d ", imgWidth , imgHeight)
StatusBar.Panel(2).Caption = Open.FileName
end sub

'============================
' Selection menu sauver sous
'============================
sub SelectMenuSaveAs
  SaveDialog.InitialDir=CurDir$
  if saveDialog.execute then
    FileName=SaveDialog.FileName
    if instr(LCASE$(FileName),".bmp")=0 then
      FileName=FileName+".bmp"
    end if
    form1.caption=application.title+" - "+FileName
    screen.cursor=crHourGlass    
    imgMemory.SaveToFile(filename)
    screen.cursor=crDefault
    FlagUndo=false
    FlagModif=false
  end if
end sub

'============================
' Selection menu sauver
'============================
sub SelectMenuSave
  if FileName="Noname" then
    SelectMenuSaveAs
  else
    screen.cursor=crHourGlass
    imgMemory.SaveToFile(filename)
    screen.cursor=crDefault
    FlagUndo=false
    FlagModif=false
  end if    
end sub

'============================
' Selection couleur crayon
'============================
Sub SelectPenColor
  ColorDial.caption="Pen Color"
  ColorDial.Color=Panel2.Color
  if ColorDial.Execute then
    Panel2.Color=ColorDial.Color
    pencolor=ColorDial.Color       
  end if
End Sub

'============================
' Selection couleur de fond
'============================
Sub SelectBackcolor
  ColorDial.caption="Background Color"
  ColorDial.Color=Panel3.Color
  if ColorDial.Execute then
    Panel3.Color=ColorDial.Color
    backcolor=ColorDial.Color       
  end if  
End Sub

'============================
' Selection pipette
'============================
Sub SelectPipe
  if btPipe.down and BtZoom.down=false then
    ResetPaste
    if focus.visible then focus.remove(image.handle)
    TypeDraw=1
    image.cursor=3
  elseif BtZoom.down=false then
    TypeDraw=0
  else
    MemoTypeDraw=1
  end if
End Sub

'============================
' Selection menu miroir x
'============================
Sub SelectMenuMirrorX
  if focus.visible then focus.remove(image.handle)
  TransfertImgUndo
  ImgEffect.pixelformat=ImgMemory.pixelformat
  ImgEffect.width=ImgMemory.width
  ImgEffect.height=ImgMemory.height
  ImgEffect.bmp=ImgMemory.bmp
  ImgEffect.mirror(0,0,ImgEffect.width,ImgEffect.height)
  ImgMemory.bmp=ImgEffect.bmp
  image.repaint
End Sub

'============================
' Selection menu miroir y
'============================
Sub SelectMenuMirrorY
  if focus.visible then focus.remove(image.handle)
  TransfertImgUndo
  ImgEffect.pixelformat=ImgMemory.pixelformat
  ImgEffect.width=ImgMemory.width
  ImgEffect.height=ImgMemory.height
  ImgEffect.bmp=ImgMemory.bmp
  ImgEffect.flip(0,0,ImgEffect.width,ImgEffect.height)
  ImgMemory.bmp=ImgEffect.bmp
  image.repaint
End Sub

'============================
' Selection menu inverser
'============================
Sub SelectMenuInvert
  if focus.visible then focus.remove(image.handle)
  TransfertImgUndo
  ImgEffect.pixelformat=ImgMemory.pixelformat
  ImgEffect.width=ImgMemory.width
  ImgEffect.height=ImgMemory.height
  ImgEffect.bmp=ImgMemory.bmp
  ImgEffect.invertColor(0,0,ImgEffect.width,ImgEffect.height)
  ImgMemory.bmp=ImgEffect.bmp
  image.repaint
End Sub

'=================================
' Selection menu inverser couleur
'=================================
Sub SelectMenuInvertColor
  if focus.visible then focus.remove(image.handle)
  TransfertImgUndo
  ImgEffect.pixelformat=ImgMemory.pixelformat
  ImgEffect.width=ImgMemory.width
  ImgEffect.height=ImgMemory.height
  ImgEffect.bmp=ImgMemory.bmp
  source.left=0
  source.top=0
  source.right=ImgMemory.width
  source.bottom=ImgMemory.height
  dest.left=0
  dest.top=0
  dest.right=ImgMemory.width
  dest.bottom=ImgMemory.height
  imgMemory.fillrect(0,0,imgMemory.width,imgMemory.height,backcolor)
  imgMemory.copymode=cmSrcInvert
  imgMemory.copyrect(Dest,ImgEffect,Source)
  imgMemory.copymode=cmSrcCopy
  image.repaint
End Sub

'============================
' Selection menu coloriser
'============================
Sub SelectMenuColoring
  if focus.visible then focus.remove(image.handle)
  TransfertImgUndo
  ImgEffect.pixelformat=ImgMemory.pixelformat
  ImgEffect.width=ImgMemory.width
  ImgEffect.height=ImgMemory.height
  ImgEffect.bmp=ImgMemory.bmp
  source.left=0
  source.top=0
  source.right=ImgMemory.width
  source.bottom=ImgMemory.height
  dest.left=0
  dest.top=0
  dest.right=ImgMemory.width
  dest.bottom=ImgMemory.height
  imgMemory.fillrect(0,0,imgMemory.width,imgMemory.height,backcolor)
  imgMemory.copymode=cmMergeCopy
  imgMemory.copyrect(Dest,ImgEffect,Source)
  imgMemory.copymode=cmSrcCopy
  image.repaint
End Sub

'===================================
' Selection menu transparence image
'===================================
Sub SelectMenuTransparentImage
  if focus.visible then focus.remove(image.handle)
  TransfertImgUndo
  ImgEffect.pixelformat=ImgMemory.pixelformat
  ImgEffect.width=ImgMemory.width
  ImgEffect.height=ImgMemory.height
  ImgEffect.bmp=ImgMemory.bmp
  source.left=0
  source.top=0
  source.right=ImgMemory.width
  source.bottom=ImgMemory.height
  dest.left=0
  dest.top=0
  dest.right=ImgMemory.width
  dest.bottom=ImgMemory.height
  imgMemory.fillrect(0,0,imgMemory.width,imgMemory.height,backcolor)
  imgMemory.copymode=cmMergePaint
  imgMemory.copyrect(Dest,ImgEffect,Source)
  imgMemory.copymode=cmSrcCopy
  image.repaint
End Sub

'===================================
' Selection menu supprimer couleur
'===================================
Sub SelectMenuRemoveColor
  dim i as integer
  dim j as integer

  if focus.visible then focus.remove(image.handle)
  screen.cursor=crHourGlass
  TransfertImgUndo
  for i=0 to ImgMemory.width
    for j=0 to ImgMemory.height
      if image.Pixel(i,j)=backcolor then ImgMemory.pset(i,j,&hffffff)
    next j
  next i
  screen.cursor=crDefault
  image.repaint
End Sub

'=============================
' Selection menu rotation 90
'=============================
Sub SelectMenuRotation
  if focus.visible then focus.remove(image.handle)
  TransfertImgUndo
  screen.cursor=crHourGlass
  ImgEffect.pixelformat=ImgMemory.pixelformat
  if ImgMemory.width>ImgMemory.height then
    ImgEffect.width=ImgMemory.width
    ImgEffect.height=ImgMemory.width
    ImgEffect.draw(0,((ImgMemory.width-ImgMemory.height)/2),ImgMemory.bmp)
    source.left=(ImgMemory.width-ImgMemory.height)/2
    source.top=0
    source.right=source.left+ImgMemory.height
    source.bottom=ImgMemory.width
    dest.left=0
    dest.top=0
    dest.right=ImgMemory.height
    dest.bottom=ImgMemory.width  
  else
    ImgEffect.width=ImgMemory.height
    ImgEffect.height=ImgMemory.height
    ImgEffect.draw(((ImgMemory.height-ImgMemory.width)/2),0,ImgMemory.bmp)
    source.left=0
    source.top=(ImgMemory.height-ImgMemory.width)/2
    source.right=ImgMemory.height
    source.bottom=source.top+ImgMemory.width
    dest.left=0
    dest.top=0
    dest.right=ImgMemory.height
        dest.bottom=ImgMemory.width  
  end if  
  ImgEffect.rotate((ImgEffect.width/2),(ImgEffect.height/2),90)
  ImgMemory.width=Imgheight
  ImgMemory.height=Imgwidth
  ImgMemory.copyrect(dest,ImgEffect,source)
  Image.width=Imgheight
  Image.height=Imgwidth
  Imgheight=Image.height
  Imgwidth=Image.width
  screen.cursor=crdefault
  image.repaint
End Sub  

'============================
' Selection zoom
'============================
Sub SelectZoom
  if BtZoom.down then
    MemoTypeDraw=TypeDraw
    ResetPaste
    if focus.visible then focus.remove(image.handle)
    TypeDraw=0
    ImageMenu.enabled=false
    EditMenu.enabled=false
    FileMenu.enabled=false
    image.cursor=crnone
  else
    image.cursor=crdefault
    if focus.visible then focus.remove(image.handle)
    FileMenu.enabled=true
    ImageMenu.enabled=true
    EditMenu.enabled=true
    TypeDraw=MemoTypeDraw
    if flagZoom then
      ImgMemory.width=imgwidth
      ImgMemory.height=imgheight
      ImgMemory.bmp=ImgTmp.bmp
      image.width=imgwidth
      image.height=imgheight
    end if
    flagZoom=false
  end if
End Sub

'============================
' Zoom image
'============================
Sub Zoom
  TransfertImgUndo
  ImgZoom.width=ZoomWidth
  ImgZoom.height=ZoomHeight
  imgZoom.pixelformat=ImgMemory.pixelformat
  source.left=focus.left
  source.top=focus.top
  source.right=focus.left+focus.width
  source.bottom=focus.top+focus.height
  dest.left=0
  dest.top=0
  dest.right=focus.width
  dest.bottom=focus.height  
  imgZoom.copyrect(dest,image,source)
  ImgTmp.width=ImgMemory.width
  ImgTmp.height=ImgMemory.height
  ImgTmp.bmp=ImgMemory.bmp
  ImgTmp.pixelformat=ImgMemory.pixelformat
  source.left=0
  source.top=0
  source.right=(ImgZoom.width*ValZoom)/100
  source.bottom=(ImgZoom.height*ValZoom)/100
  ImgMemory.width=(ImgZoom.width*ValZoom)/100
  ImgMemory.height=(ImgZoom.height*ValZoom)/100
  ImgMemory.StretchDraw(source,ImgZoom.bmp)
  image.width=(ImgZoom.width*ValZoom)/100
  image.height=(ImgZoom.height*ValZoom)/100
End Sub
'============================
' Selection focus
'============================
Sub SelectFocus(Sender as QMenuItem)
  if btFocus.down and BtZoom.down=false then
    ResetPaste
    TypeDraw=10
    image.cursor=crdefault
  elseif BtZoom.down=false then
    TypeDraw=0
    if focus.visible then focus.remove(image.handle)
    ItemCut.enabled=false
    ItemCopy.enabled=false
  else
    MemoTypeDraw=10
  end if
End Sub

'============================
' Selection crayon
'============================
Sub SelectPen
  if btPen.down and BtZoom.down=false then
    ResetPaste
    if focus.visible then focus.remove(image.handle)
    TypeDraw=2
    image.cursor=1
    image.pensize=val(PenSize.item(PenSize.itemindex))
    imgMemory.pensize=val(PenSize.item(PenSize.itemindex))
  elseif BtZoom.down=false then
    TypeDraw=0
    image.cursor=crdefault
  else
    MemoTypeDraw=2
  end if
End Sub

'============================
' Selection pinceau
'============================
Sub SelectPaint
  if btBrush.down and BtZoom.down=false then
    ResetPaste
    if focus.visible then focus.remove(image.handle)
    TypeDraw=2
    image.cursor=5
    image.pensize=val(PenSize.item(PenSize.itemindex))*10
    imgMemory.pensize=val(PenSize.item(PenSize.itemindex))*10
  elseif BtZoom.down=false then
    TypeDraw=0
    image.cursor=crdefault
    image.pensize=val(PenSize.item(PenSize.itemindex))
    imgMemory.pensize=val(PenSize.item(PenSize.itemindex))
  else
    MemoTypeDraw=2
  end if
End Sub

'============================
' Selection ligne
'============================
Sub SelectLine
  if btLine.down and BtZoom.down=false then
    ResetPaste
    if focus.visible then focus.remove(image.handle)
    TypeDraw=4
    image.cursor=1
    image.pensize=val(PenSize.item(PenSize.itemindex))
    imgMemory.pensize=val(PenSize.item(PenSize.itemindex))
  elseif BtZoom.down=false then
    image.cursor=crdefault
    TypeDraw=0
  else
    MemoTypeDraw=4
  end if
End Sub

'============================
' Selection rectangle
'============================
Sub SelectRect
  if btSquare.down and BtZoom.down=false  then
    ResetPaste
    if focus.visible then focus.remove(image.handle)
    TypeDraw=5
    image.cursor=1
    image.pensize=val(PenSize.item(PenSize.itemindex))
    imgMemory.pensize=val(PenSize.item(PenSize.itemindex))
  elseif BtZoom.down=false then
    image.cursor=crdefault
    TypeDraw=0
  else
    MemoTypeDraw=5
  end if
End Sub

'============================
' Selection rectangle plein
'============================
Sub SelectRectFilled
  if btSquareFilled.down and BtZoom.down=false then
    ResetPaste
    if focus.visible then focus.remove(image.handle)
    TypeDraw=6
    image.cursor=1
    image.pensize=val(PenSize.item(PenSize.itemindex))
    imgMemory.pensize=val(PenSize.item(PenSize.itemindex))
  elseif BtZoom.down=false then
    image.cursor=crdefault
    TypeDraw=0
  else
    MemoTypeDraw=6
  end if
End Sub

'============================
' Selection cercle
'============================
Sub SelectCircle
  if btCircle.down and BtZoom.down=false then
    ResetPaste
    if focus.visible then focus.remove(image.handle)
    TypeDraw=7
    image.cursor=1
    image.pensize=val(PenSize.item(PenSize.itemindex))
    imgMemory.pensize=val(PenSize.item(PenSize.itemindex))
  elseif BtZoom.down=false then
    image.cursor=crdefault
    TypeDraw=0
  else
    MemoTypeDraw=7
  end if
End Sub

'============================
' Selection cercle plein
'============================
Sub SelectCircleFilled
  if btCircleFilled.down and BtZoom.down=false then
    ResetPaste
    if focus.visible then focus.remove(image.handle)
    TypeDraw=8
    image.cursor=1
    image.pensize=val(PenSize.item(PenSize.itemindex))
    imgMemory.pensize=val(PenSize.item(PenSize.itemindex))
  elseif BtZoom.down=false then
    image.cursor=crdefault
    TypeDraw=0
  else
    MemoTypeDraw=8
  end if
End Sub

'============================
' Selection remplissage
'============================
Sub SelectFill
  if btFill.down then
    ResetPaste
    if focus.visible then focus.remove(image.handle)
    TypeDraw=9
    image.cursor=2
  else
    image.cursor=crdefault
    TypeDraw=0
  end if
End Sub

'============================
' Selection texte
'============================
Sub SelectText
  if btText.down and BtZoom.down=false then
    ResetPaste
    if focus.visible then focus.remove(image.handle)
    TypeDraw=3
    image.cursor=crdefault
  elseif BtZoom.down=false then
    TypeDraw=0
  else
    MemoTypeDraw=3
  end if
End Sub

'================================================
' Selection police du texte boite dialogue texte
'================================================
Sub SelectTextFont
  if fontdialog.execute then
    fontdialog.setfont(font)
    EdText.font=font
    image.font=font
  end if
End Sub

'============================================
' Selection annuler boite dialogue texte
'============================================
Sub AnnulerText
  Form3.close
  EdText.text=""
  FlagText=false
End Sub

'===================================
' Selection ok boite dialogue texte
'===================================
Sub OkText
  TransfertImgUndo
  FlagText=true
  Form3.close
  image.repaint
End Sub

'==========================================
' Evenement mouse down du composant image
'==========================================
Sub Start(bt as integer,x as integer,y as integer)
    flagDraw=true
    orx=x
    ory=y
    ox=x
    oy=y
    Select Case typeDraw
    Case 1
      'pipette couleur
      if bt=0 then
        Panel2.Color=image.pixel(x,y)
        pencolor=image.pixel(x,y) 
      elseif bt=1 then
        Panel3.Color=image.pixel(x,y)
        backcolor=image.pixel(x,y) 
      end if
    Case 2
      'crayon
      TransfertImgUndo
      image.line(x,y,x,y,PenColor)
      imgMemory.line(x,y,x,y,PenColor)
    Case 3
      'texte
      leftText=x
      topText=y
      Form3.show
    Case 4
     'ligne
     TransfertImgUndo
     image.mixmode=10
     image.line(x,y,x,y,PenColor)
   Case 5,6
     'rectangle
     TransfertImgUndo
     image.mixmode=10
     image.rectangle(x,y,x,y,PenColor)
   Case 7,8
     'cercle
     TransfertImgUndo
     image.mixmode=10
     image.circle(x,y,x,y,PenColor)
' type mixmode
'R2_BLACK_CAN=1
'R2_NOTMERGEPEN_CAN=2
'R2_MASKNOTPEN_CAN=3
'R2_NOTCOPYPEN_CAN=4
'R2_MASKPENNOT_CAN=5
'R2_NOT_CAN=6
'R2_XORPEN_CAN=7
'R2_NOTMASKPEN_CAN=8
'R2_MASKPEN_CAN=9
'R2_NOTXORPEN_CAN=10
'R2_NOP_CAN=11
'R2_MERGENOTPEN_CAN=12
'R2_COPYPEN_CAN=13
'R2_MERGEPENNOT_CAN=14
'R2_MERGEPEN_CAN=15
'R2_WHITE_CAN=16

   Case 9
     'remplissage
     TransfertImgUndo
     image.fillSurface(x,y,pencolor)
     imgMemory.fillSurface(x,y,pencolor)
   Case 10  
     'focus
     if flagPaste=false then focus.noResize=false
     focus.showcursor=true
     focus.start(image.handle,x,y) 
   end select
  if btZoom.down and flagZoom then
    image.fillSurface(x,y,pencolor)
    imgTmp.pixel(int(x/8)+focus.left,int(y/8)+focus.top)=pencolor
  elseif btZoom.down and flagZoom=false then  
    focus.remove(image.handle)
    flagZoom=true
    Zoom
    image.cursor=1
  end if 
End Sub 

'=========================================
' Evenement mouse move du composant image
'=========================================
sub Move(x as integer,y as integer)
  select case typeDraw
  case 2
    if flagDraw then
      image.line(ox,oy,x,y,PenColor)
      imgMemory.line(ox,oy,x,y,PenColor)
    end if 
  case 4
    if flagDraw then
      image.line(orx,ory,ox,oy,PenColor)
      image.line(orx,ory,x,y,PenColor)
    end if
  case 5,6
    if flagDraw then
      image.rectangle(orx,ory,ox,oy,PenColor)
      image.rectangle(orx,ory,x,y,PenColor)
    end if
  case 7,8
    if flagDraw then
      image.circle(orx,ory,ox,oy,PenColor)
      image.circle(orx,ory,x,y,PenColor)
    end if
  case 10
    focus.draw(image.handle,x,y,flagDraw) 
  end select
  ox=x
  oy=y
  if btZoom.down and flagZoom=false then
    focus.showcursor=false
    if focus.visible then focus.remove(image.handle)
    focus.start(image.handle,x,y)
    focus.draw(image.handle,x+ZoomWidth,y+ZoomHeight,true)
  end if
StatusBar.Panel(1).Caption = Format$(" X: %d Y: %d ",x,y)
End Sub 

'=======================================
' Selection mouse up du composant image
'=======================================
sub Stop
  if flagDraw then
    image.mixmode= 13 'R2_COPYPEN_CAN
    flagDraw=false
  end if
    select case typeDraw
    case 4
      image.line(orx,ory,ox,oy,PenColor)
      imgMemory.line(orx,ory,ox,oy,PenColor)
    case 5
      image.rectangle(orx,ory,ox,oy,PenColor)
      imgMemory.rectangle(orx,ory,ox,oy,PenColor)
    case 6
      image.rectangleFilled(orx,ory,ox,oy,PenColor,backcolor)
      imgMemory.rectangleFilled(orx,ory,ox,oy,PenColor,backcolor)
    case 7
      image.circle(orx,ory,ox,oy,PenColor)
      imgMemory.circle(orx,ory,ox,oy,PenColor)
    case 8
      image.circleFilled(orx,ory,ox,oy,PenColor,backcolor)
      imgMemory.circleFilled(orx,ory,ox,oy,PenColor,backcolor)
    case 10
      if FlagPaste then
        TransfertImgUndo
        focus.remove(image.handle)
        focus.stop(image.handle,false)
        if focus.move then
          ImgMemory.draw(focus.left,focus.top,ImgEffect.bmp)
        else
          ImgMemory.draw(0,0,ImgEffect.bmp)
        end if 
        TypeDraw=0
        image.repaint
      else
        focus.stop(image.handle,false) 
      end if
    end select
    FlagPaste=false
End Sub 

'============================
' Selection menu dimensions
'============================
Sub SelectMenuDimensions
  WidthEdit.text=str$(imgWidth)
  HeightEdit.text=str$(imgHeight)
  Form2.show
End Sub

'========================================
' Selection ok boite dialogue dimensions
'========================================
Sub OkDimensions
  TransfertImgUndo
  imgWidth=val(WidthEdit.text)
  imgHeight=val(HeightEdit.text)
  if CheckStretch.checked then
    ImgTmp.width=ImgMemory.width
    ImgTmp.height=ImgMemory.height
    ImgTmp.bmp=ImgMemory.bmp
    ImgTmp.pixelformat=ImgMemory.pixelformat
    source.left=0
    source.top=0
    source.right=imgWidth
    source.bottom=imgHeight
    ImgMemory.width=imgWidth
    ImgMemory.height=imgHeight
    ImgMemory.StretchDraw(source,ImgTmp.bmp)
  else
    imgMemory.width=imgWidth
    imgMemory.height=imgHeight
  end if
  image.width=imgWidth
  image.height=imgHeight
  Form2.close
End Sub

'=============================================
' Selection annuler boite dialogue dimensions
'=============================================
Sub AnnulerDimensions
  WidthEdit.text=str$(imgWidth)
  HeightEdit.text=str$(imgHeight)
  Form2.close
End Sub

'============================
' Selection taille crayon
'============================
Sub SelectPenSize
  if if btBrush.down then
    image.pensize=val(PenSize.item(PenSize.itemindex))*10
    imgMemory.pensize=val(PenSize.item(PenSize.itemindex))*10
  else
    image.pensize=val(PenSize.item(PenSize.itemindex))
    imgMemory.pensize=val(PenSize.item(PenSize.itemindex))
  end if
End Sub

'============================
' Affichage grille zoom
'============================
Sub Grille
  dim ptHorz as integer
  dim ptVert as integer
  dim i as integer
    
  ptHorz=0
  ptVert=0
  image.pensize=1
  for i=1 to int(imgMemory.height/8)
    ptHorz=ptHorz+8
    image.line(0,ptHorz,imgMemory.width,ptHorz,&h0)
  next i 
  for i=1 to int(imgMemory.width/8)
    ptVert=ptVert+8
    image.line(ptVert,0,ptVert,imgMemory.height,&h0)
  next i 
  if btBrush.down then
    image.pensize=val(PenSize.item(PenSize.itemindex))*10
  else
    image.pensize=val(PenSize.item(PenSize.itemindex))
  end if
End Sub

'================================
' Mise a jour image d'annulation
'================================
Sub TransfertImgUndo
  imgUndo.pixelformat=ImgMemory.pixelformat
  ImgUndo.width=ImgMemory.width
  ImgUndo.height=ImgMemory.height
  ImgUndo.bmp=ImgMemory.bmp
  FlagUndo=true
  FlagModif=true
End Sub

'===============================
' Evenement onkey fenetre ecran
'===============================
Sub FermerEcran(Key as word)
  if Key=VK_ESCAPE then
    form4.close
    form1.show
  end if
End Sub

'================================
' Selection menu affichage ecran
'================================
Sub SelectMenuImageShow
  dim reduction as integer
  dim reduction1 as integer
  dim reduction2 as integer
  dim showWidth as integer
  dim showHeight as integer
  
  form1.visible=false
  form4.show
  reduction=100
  reduction1=100
  reduction2=100
  showWidth=ImgMemory.width
  showHeight=ImgMemory.Height
  if showWidth>Screen.Width or showHeight>Screen.Height then
    if showWidth>Screen.Width then
      reduction1=100-Ratio(showWidth,Screen.Width)
    end if
    if showHeight>Screen.Height then
      reduction2=100-Ratio(showHeight,Screen.Height)
    end if
    if reduction1<reduction2 then
      reduction=reduction1
    else
      reduction=reduction2
    end if
    if reduction1=reduction2 then reduction=reduction1
  end if
  ecran.left=int((Screen.Width-((showWidth*reduction)/100))/2)
  ecran.top=int((Screen.Height-((showHeight*reduction)/100))/2)
  ecran.Width=int(showWidth*(reduction/100))
  ecran.Height=int(showHeight*(reduction/100))
  ecran.bmp=ImgMemory.bmp
  ecran.visible=true
End Sub  

'============================
' Selection menu a propos
'============================
sub SelectMenuAbout
  about.Appname=Application.title 
  about.Appversion="1.0" 
  about.caption="About "+about.Appname 
  about.text="Author: D.Glodt" + chr$(10 )+ "Modified by : Nastase Eodor" _
              + chr$(10) + "Copyright " + chr$(169) + " eBorg Software 2002-2004 "
  about.image.icohandle=ico 
  about.show 
end sub 

'============================
' Reset boutons
'============================
Sub ResetButton
  image.cursor=crDefault
  if btFocus.down then btFocus.down=false
  if btPipe.down then btPipe.down=false
  if btFill.down then btFill.down=false
  if btText.down then btText.down=false
  if btBrush.down then btBrush.down=false
  if btPen.down then btPen.down=false
  if btLine.down then btLine.down=false
  if btSquare.down then btSquare.down=false
  if btSquareFilled.down then btSquareFilled.down=false
  if btCircle.down then btCircle.down=false
  if btCircleFilled.down then btCircleFilled.down=false
End Sub

'===============================
' Conversion format 16 couleurs
'===============================
Sub SelectMenuFormat16
  TransfertImgUndo
  ImgMemory.pixelformat=pf4bit
  ShowFormat
  image.repaint
End Sub

'===============================
' Conversion format 256 couleurs
'===============================
Sub SelectMenuFormat256
  TransfertImgUndo
  ImgMemory.pixelformat=pf8bit
  ShowFormat
  image.repaint
End Sub

'====================================
' Conversion format couleurs 24 bits
'====================================
Sub SelectMenuFormat24
  TransfertImgUndo
  ImgMemory.pixelformat=pf24bit
  ShowFormat
  image.repaint
End Sub

'===============================
' Affiche le format couleur
'===============================
Sub ShowFormat
  Select case ImgMemory.pixelformat
  case 2
    itemFormat16.checked=true 
    itemFormat256.checked=false
    itemFormat24.checked=false
  case 3 
    itemFormat256.checked=true 
    itemFormat24.checked=false
    itemFormat16.checked=false
  case else
    itemFormat24.checked=true 
    itemFormat16.checked=false
    itemFormat256.checked=false
  end select 
End Sub
